package com.nisum.offertransactionservice.controller;

import com.nisum.offertransactionservice.model.*;
import com.nisum.offertransactionservice.service.EndOfSaleService;
import com.nisum.offertransactionservice.service.EndOfTransactionService;
import com.nisum.offertransactionservice.service.OfferCallingPEService;
import org.slf4j.MDC;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.io.IOException;
import java.util.List;
import java.util.UUID;

@RestController
@CrossOrigin
public class OfferTransactionController {

    @Autowired
    private OfferCallingPEService offerCallingPEService;

    @Autowired
    private EndOfSaleService endOfSaleService;

    @Autowired
    private EndOfTransactionService endOfTransactionService;

    @PostMapping("offerTransactionCall")
    public OfferTransactionResponse getOfferTransactionResponse(@Valid @RequestBody OfferTransactionRequest offerTransactionRequest) throws InterruptedException {
        Thread.sleep(1000);
        MDC.put("swy-res-unique-uuid", offerTransactionRequest.getHhId());
        MDC.put("user-id", offerTransactionRequest.getHhId());
        return offerCallingPEService.getDiscountedItemList(offerTransactionRequest);
    }


    @PostMapping("endOfSale")
    public EndOfSaleResponse endOfSale(@Valid @RequestBody EndOfSaleReq endOfSaleReq) throws IOException {
        MDC.put("swy-res-unique-uuid", endOfSaleReq.getOfferTransactionResponse().getHhid());
        MDC.put("user-id", endOfSaleReq.getOfferTransactionResponse().getHhid());
        UUID uuid = endOfSaleService.putEndofSaleResInDb(endOfSaleReq);
        EndOfSaleResponse endOfSaleResponse = new EndOfSaleResponse();
        endOfSaleResponse.setUuId(uuid.toString());
        return endOfSaleResponse;
    }




    @PostMapping("/endOfTransaction")
    public String endOfTransaction(@Valid @RequestBody String uuid) {
        MDC.put("swy-res-unique-uuid", uuid);
        MDC.put("user-id", uuid);
        return endOfTransactionService.endOfTransaction(uuid);

    }

}



